#ifndef __NEO_CODES_H
#   define __NEO_CODES_H__

#define SIZEOF_PINPAIR_DEF      10

#define LOADABLE_UNITS "circuits"
#define LINKABLE_UNITS "o.$ARCH"
#define FOLDER_DIR     "folders"
#define SYNOPSIS_FILE  "synopsis"

/******** some special markers to separate file sections: ***********/

#define END_OF_CIRCUIT "##_____END_OF_CIRCUIT_____"
#define BGN_OF_NSTDATA "##_____BGN_OF_NSTDATA_____"
#define END_OF_NSTFILE "##_____END_OF_NSTFILE_____"

#define FOLDER_ENDMARK  "__NEXT__"
#define REQUEST_ENDMARK "__END__"

/******** codes for communicating with server: ***********/

#define DIAGNOSTIC (1U<<0)
#define ASYNC_MODE (1U<<1)

/*********************************************************/
/*   Return codes: these should be only one char long!   */

#define SRV_OK            "+"   
#define SRV_ERROR         "-"   
#define SRV_BUSY          "!"   
#define SRV_DONE          "D"   
#define SRV_FATAL         "F"   
#define SRV_CONFIRM_STOP  "?"   

/*********************************************************/

#define START_SERVER             9
#define EXIT                    10
#define COMMAND_LINE            11
#define LOAD_FOLDERS            12
#define GET_FOLDERS             13
#define CREATE_UNIT             14
#define MODIFY_UNIT             15
#define CONFIG_UNIT             16
#define REMOVE_UNITS            17
#define QUEUE_UNIT              18
#define SELECT_CONTAINER        19
#define CREATE_CONTAINER        20
#define ENTER_CONTAINER         21
#define LEAVE_CONTAINER         22
#define CAN_REPLACE0            26 
#define CAN_REPLACE             23 
#define CHANGE_HOST0            24 
#define CHANGE_HOST             25
/* 26 is taken */ 
#define GET_NAME                27 
#define FIND_UNIT_BY_NAME       28 
#define DO_EXEC_AND_ADAPT       29 
#define DO_EXEC                 30
#define NAME_UNIT               31 
#define UNNAME_UNIT             32 
#define ADMITS_OPND_OFFSET      33
#define HAS_FIXED_SCOPE         34
#define GET_NUM_OPNDS           35
#define SET_NUM_OPNDS           36
#define GET_FIRST_OPND          37 
#define SET_FIRST_OPND          38 
#define VIRTUAL_FOR_OP          39 
#define CTRL_UNIT               40
#define DO_JOINFIELDS           41
#define DO_JOINPINS             42
#define UNJOIN_PQ               43
#define COMPATIBLE_PP           44
#define REMOVE_WIRE             45
#define CREATE_WIRE             46
#define COMPATIBLE_FF           47
#define SAVE_UNIT               48
#define LOAD_UNIT               49
#define LOAD_SUBUNITS           50 
#define PIN_HAS_WRITER          51 
#define UNRESOLVED_REFERENCE    52 
#define IMMEDIATE_JOIN          53 
#define UNDEF_FIELD_DIMENSIONS  54 
#define REDEF_FIELD_DIMENSIONS  55 
#define BEGIN_MODIFY_FIELD      56 
#define MODIFY_FIELD            57 
#define END_MODIFY_FIELD        58 
#define ADD_FIELD               59 
#define EXPAND_F                60 
#define DESCRIBE_FIELD          61 
#define GET_SUBUNITS            62 
#define SET_NAME_OF_VIRTUAL_METHOD 63 
#define GET_NAME_OF_VIRTUAL_METHOD 64 
#define METHOD_IS_BOUND         65 
#define COPY_PARS_FOR_VIRTUAL_METHODS 66 
#define GET_ADR_OF_CIRCUIT      67 
#define SELECT_CIRCUIT          68 
#define GET_CIRCUIT             69 
#define PUT_CIRCUIT             70 
#define GET_LABEL               71 
#define CREATE_CONTAINER0       72 
#define DETACH                  73 
#define MAP_WINDOWS             74 
#define UNMAP_WINDOWS           75 
#define FIND_FILE               76 
#define ASK_IF_BUSY             77 
#define STOP_EXEC               78 
#define DECIDE_CONFIRM          79 
#define DUMMY_ICON              80 
#define MODIFY_PIN              81 
#define CHANGE_SCALAR_PIN       82 
#define REMOVE_FIELD            83 
#define IS_CONNECTED            84 
#define GET_HIERARCHY           85 
#define UPDATE_ICON             86 
#define TRANSLATE_WIRES         87 
#define SAVE_CIRCUIT            88
#define LOAD_CIRCUIT            89
#define GET_CREATE_FORMAT       90
#define GET_CREATE_DATA         91 
#define GET_CONFIG_FORMAT       92
#define GET_CONFIG_DATA         93
#define GET_USERDEF_FORMAT      94
#define GET_USERDEF_DATA        95
#define DEFINE_DIALOG           96
#define UNDEFINE_DIALOG         97
#define COPY_CIRCUIT            98 
#define DUMP                    99 
#define DERIVE_UNIT            100 
#define REPLACE_TOPLEVEL_CIRCUIT 101 
#define SYNC_SERVER            102 
#define UPDATE_INTERFACE       103
#define UPDATE_ANNOTATION      104 
#define ICON_INTO_FOLDER       105 
#define GET_PREFS              106 
#define SET_PREFS              107 
#define MOVE_WIRES             108 
#define INSERT_PIN             109 
#define DUPLICATE_PIN          110 
#define REMOVE_PIN             111 

#define CONTAINER_FLAG          (1UL<<0)
#define VIRTUAL_METHOD_FLAG     (1UL<<1)
#define USE_METHOD_FLAG         (1UL<<2)
#define USE_NAMED_UNIT_FLAG     (1UL<<3)
#define EXPORT_METHODS_FLAG     (1UL<<4)
#define ICON_SELECT_FLAG        (1UL<<5)
#define MANPAGE_FLAG            (1UL<<6)
#define EXAMPLE_FLAG            (1UL<<7)
#define VIRTUAL_FOR_OP_FLAG     (1UL<<8)
#define MARKER_FLAG             (1UL<<9)
#define DUMMY_ICON_FLAG         (1UL<<10)

#endif

