#ifndef CARCHIV_H
#define CARCHIV_H


#include <iostream>
#include <iomanip>
#include <string.h>
#include <CObject.h>

using namespace std;




/*!
 *@brief Base class of object serialization
 *
 **/
class CArchiv {


public:
	CArchiv() {};
	virtual ~CArchiv() { cout << setiosflags(ios_base::scientific);};
	virtual bool isReading() const  { return false; };
	virtual void flush() { cout << endl; };
	virtual void operator<<(const float& value)          { cout << value << " ";};
	virtual void operator<<(const double& value)         { cout << value << " "; };
	virtual void operator<<(const unsigned int& value)   { cout << value << " "; };
	virtual void operator<<(const int& value)            { cout << value << " "; };
	virtual void operator<<(const long& value)            { cout << value << " "; };
	virtual void operator<<(const unsigned long& value)            { cout << value << " "; };
	virtual void operator<<(const unsigned short& value) { cout << value << " "; };
	virtual void operator<<(const short& value)          { cout << value << " "; };
	virtual void operator<<(const unsigned char& value)  { cout << value << " "; };
	virtual void operator<<(const char& value)           { cout << value << " "; };
	virtual void operator<<(const bool& value)           { cout << value << " "; };
	virtual void operator<<(const string& str)           { cout << str << " "; };
	virtual void operator<<(const char* str)             { cout << str << " "; };
	virtual void operator<<(CObject<float>& tObj)  {
		cout << ">>>" << tObj.className() << endl;
		if(!tObj.serialize2(*this))
			cout << "Error during serialization of " << tObj.className().c_str() << endl;
		cout << "<<<" << tObj.className() << endl;
	};
	virtual void operator<<(CObject<double>& tObj) {
		if(!tObj.serialize2(*this)) cout << "Error during serialization of " << tObj.className() << endl;
	};
	virtual void operator<<(CObject<int>& tObj)    {
		if(!tObj.serialize2(*this)) cout << "Error during serialization of " << tObj.className() << endl;
	};


	virtual void operator>>(float& value)          {};
	virtual void operator>>(double& value)         {};
	virtual void operator>>(unsigned int& value)   {};
	virtual void operator>>(int& value)            {};
	virtual void operator>>(long& value)            {};
	virtual void operator>>(unsigned long& value)            {};
	virtual void operator>>(unsigned short& value) {};
	virtual void operator>>(short& value)          {};
	virtual void operator>>(unsigned char& value)  {};
	virtual void operator>>(char& value)           {};
	virtual void operator>>(bool& value)           {};
	virtual void operator>>(string& str)           {};
	virtual void operator>>(char* str)             {};
	virtual void operator>>(CObject<float>& tObj)  {
		if(!tObj.serialize2(*this)) cout << "Error during serialization of " << tObj.className() << endl;
	};
	virtual void operator>>(CObject<double>& tObj) {
		if(!tObj.serialize2(*this)) cout << "Error during serialization of " << tObj.className() << endl;
	};
	virtual void operator>>(CObject<int>& tObj)    {
		if(!tObj.serialize2(*this)) cout << "Error during serialization of " << tObj.className() << endl;
	};



};


#endif
