#ifndef CSVMModel_H
#define CSVMModel_H

#include "CObject.h"
#include "CSVCandidate.h"
#include "CVector.h"
#include "CDenseVector.h"
#include "CKernel.h"
#include "CArchiv.h"

template<class Type>
class CSVMModel : public CObject<Type>{
protected:
	vector< CSVCandidate<Type> > m_tSVs;
	CKernel<Type>* m_ptKernel;
	CDenseVector<Type> m_tWeight;
	Type m_tBias;
	Type m_tSigmoidA;
	Type m_tSigmoidB;
	bool m_bCalibrated;
public:
	CSVMModel();
	CSVMModel(const vector<CSVCandidate<Type> >& rtSVs, const CKernel<Type>& rtKernel, Type tBias, Type tSigmoidA=0, Type tSigmoidB=0);
	CSVMModel(const CSVMModel<Type>& rtModel);
	~CSVMModel();
	CSVMModel<Type>& operator=(const CSVMModel<Type>& rtModel);
	bool serialize2(CArchiv& tAr);
	int classify(const CVector<Type>& rtPattern) const;
	void classify(const CVector<Type>& rtPattern, Type& rtClass, Type& rtMargin) const;
	string className() const { return "CSVMModel";};
	bool isA(const char* acClass) const { if(string(acClass) == this->className()) return true; else return CObject<Type>::isA(acClass);};
};

#endif
