#ifndef __DATABASE_EXCEPTION_H
#define __DATABASE_EXCEPTION_H

#include <string>
#include <iostream>


class CDatabaseException
{
private:
	std::string msg;
	std::string file;
	int line;

public:
	CDatabaseException(const char* msg, const char* file, int line) :
		msg(msg), file(file), line(line) {
	}
	virtual ~CDatabaseException() {};

	virtual const std::string getMessage() const {
		return msg;
	}
	const std::string getSourcefile() const {
		return file;
	}
	int getSourceline() const {
		return line;
	}
};

inline std::ostream& operator<< (std::ostream& s, const CDatabaseException& ex)
{
	s << "CDatabaseException[msg=" << ex.getMessage()
	  << ", file=" << ex.getSourcefile()
	  << ":" << ex.getSourceline()
	  << "]\n";
	return s;
}

#endif
