/***************************************************************************
 *
 *  This file defines all icon directories that are known to neo.
 *  For adding a directory NAME add a line DEFFOLDER(NAME) and
 *  ADD_FOLDER(NAME) in the corresponding places.
 *  (adding a directory requires recompilation of this file
 *   and relinking with neo.o. Therefore, don't forget to include
 *   the new folder also in FOLDERS in the makefile neo.mak!)
 *
 *  Copyright Helge Ritter 1994
 *
 **************************************************************************/

/***************************************************************************
 *
 *  Configuration file for neo/libneo:
 *
 *  This file adds any user-defined folders or separate icons to
 *  the base configuration that is defined in neo_defs.h
 *
 *  #define NEOMAIN to compile a standalone version of neo
 *          (otherwise, neo's main() becomes renamed to neo_main() and
 *           main() has to be provided by user-provided linked objects)
 *
 *  Use ADD_FOLDER(name)     for adding a folder with name "name"
 *      ADD_ICON(icon,name)  for adding an icon named "icon" to folder "name"
 * 
 *  NOTE:   1. an icon may be added to more than one folder
 *             [but to each folder only once]
 *          2. for each added icon "name", there must be a source file
 *             in which the icon is defined.
 *          3. The analogous requirement holds for added folders. 
 *          4. several configurations can be maintained using
 *             e.g. #ifdef/#elif directives
 *
 *  Copyright Helge Ritter 1995
 *
 **************************************************************************/


ADD_FOLDER(stdr);
ADD_ICON(dummy_unit,stdr);
ADD_FOLDER(screen);
/* ADD_FOLDER(math); */
ADD_FOLDER(misc);
/* ADD_FOLDER(alpha); */

