/*****************************************************************************
 *
 * glX11.h  -  defines mappings from GL functions to match the definitions in
 *             nst_X11.c
 *
 * Copyright Helge Ritter, 1992
 *
 * $Source$
 *
 * $Log$
 * Revision 1.8  2005/10/21 15:10:37  rhaschke
 * replaced function shortcuts xxx -> nst_xxx
 *
 * Revision 1.7  2005/10/14 11:28:23  rhaschke
 * cleanup
 *
 * Revision 1.6  2001/07/02 10:51:35  helge
 * (new feature) now each window can have a separate background and
 * foreground color (BLACK/WHITE is default for plot windows).
 * Former NST color index 1 is no longer white, but foreground
 * (and will thus follow background choice). For constant white
 * use color index 8, for constant black 9.
 *
 * Revision 1.5  2000/02/14 14:19:21  helge
 * added two new colors: HIGHLIGHT1 and HIGHLIGHT2
 *
 * Revision 1.4  1997/04/30 12:15:20  helge
 * forgot this one.
 *
 * Revision 1.3  1997/04/02 14:06:39  helge
 * most man pages now in source code; some corrections;
 * for list, check out new log file in main dir
 *
 * Revision 1.2  1997/03/13  10:48:54  jan
 * Dependency cleanup.
 *
 *
 *****************************************************************************/

#ifndef __GLX11_H
#define __GLX11_H

/* redefine some colors: */

/* these are more nicely ordered, but they are only
   used to specify colors for the NST-graphics units; 
   internally, everything uses the gl-colors 
*/
#define NST_BACKGROUND 0
#define NST_FOREGROUND 1
#define NST_RED     2
#define NST_GREEN   3
#define NST_BLUE    4
#define NST_YELLOW  5
#define NST_MAGENTA 6
#define NST_CYAN    7
#define NST_WHITE   8
#define NST_BLACK   9
#define NST_ORANGE  -5 
#define NST_BROWN  -5   /* temporarily */

#define BLACK   0
#define RED     1
#define GREEN   2
#define YELLOW  3
#define BLUE    4
#define MAGENTA 5
#define CYAN    6
#define WHITE   7
#define BACKGROUND  8 
#define FOREGROUND  9 
#define ORANGE  -5
#define BROWN   -5    /* temporarily */

/* these are GL colors, don't use in nst_to_gl_color */
#define WDWCOL     10
#define TEXTCOL    11 
#define BUTTCOL1   12 
#define BUTTCOL2   13
#define SLICOL1    14
#define SLICOL2    15
#define BRIGHTRIM  16
#define DARKRIM    17 
#define HIGHLIGHT1 18
#define HIGHLIGHT2 19

#define move2i nst_move2i
#define draw2i nst_draw2i
#define cmov nst_cmov
#define cmov2 nst_cmov2
#define cmov2i nst_cmov2i
#define rectfi nst_rectfi
#define strwidth nst_strwidth
#define charstr nst_charstr
#define getlwidth nst_getlwidth
#define linewidth nst_linewidth
#define rectwrite nst_rectwrite
#define lrectwrite nst_lrectwrite
#define rectread nst_rectread
#define lrectread nst_lrectread
#define font nst_font
#define recti nst_recti
#define rdr2i nst_rdr2i
#define rmv2i nst_rmv2i
#define circ nst_circ
#define rdr2 nst_rdr2
#define draw2 nst_draw2
#define move2 nst_move2
#define rectf nst_rectf
#define pnt2 nst_pnt2

#endif
