/******************************************************************************
 *
 * neo5.h  -  headers for neo5.c
 *
 * Copyright Helge Ritter, 1994
 *
 * $Source$
 * $Log$
 *
 *****************************************************************************/
#ifndef __NEO5_H
#define __NEO5_H

#include "nst_direntry.h"

extern NstFolder_t gasFolders[];
extern int NUMICONFOLDERS;
extern int giCurrentFolder;

extern char* NeoPackagePathOfFolder (NstFolder_t *psFolder);
extern char* NeoPathOfFolder (NstFolder_t *psFolder);
extern int NeoGroupOfFolder (NstFolder_t *psFolder);
extern unitptr NeoIconBoxOfFolder (NstFolder_t *psFolder);
extern char* NeoNameOfFolder (int iWhich);
extern void NeoGetFolderVersions (int iWhich, int *piMajor, int *piMinor);
extern void NeoSetGroupOfFolder (NstFolder_t *psFolder, int iGroup);
extern void NeoInitializeCompiledFolders (void);
extern NstIconDef_t* searchFolderForDef (char *pcDefName, NstFolder_t* psFolder);
extern unitptr FindPrototypeOfIcon (unitptr uIcon, NstFolder_t **ppsFolder);
extern int NeoInstantiateAsReference (char *pcLabelOfIcon, char *pcFolder);
extern NstFolder_t* NeoFindFolderByName (char *pcName);
extern NstFolder_t* NeoFindFolderByIconDef (NstIconDef_t *psIcon);
extern void NeoForUsedFoldersFprintf (FILE *fp, char *pcFmt, unitptr uIcon);
extern void NeoWriteReferencedFolders (FILE *fp, unitptr uIcon);
extern void NeoRemoveHiddenIcons (void);
extern char* NeoRemoveTrailingChar (char *pcStr, char cRemove);
extern int NeoRegisterExamplesForFolders ( int iStartFolder, int iNumFolders, char *pcPath );
extern int NeoRegisterManpagesForFolders ( int iStartFolder, int iNumFolders, char *pcPath);
extern int NeoRegisterExamples (char *pcPath);
extern int NeoRegisterManpages (char *pcPath);
extern int NeoAddCompiledFolder (NstFolder_t* psFolder);
extern void RedefineIcon (NstIconDefEntry_t *psIconDefEntry1, NstIconDefEntry_t *psIconDefEntry2);
extern char* getIconNameByDef (NstIconDef_t *psDef);
extern DIR* OpenDir (char *pcPath, char *pcMode);
extern int isLoadableFolder(int iNum);
extern int NeoUpdateLoadableFolder (int iNum);
extern int NeoAddFoldersFromFile ( FILE *fp, char *pcSearchPath, char *pcName, char iSilent );
extern void NeoDisplayFolder (int iNumFolder);
extern int  NeoAppendOrWithdrawFolder (char *pcPathAndName);

extern char* NeoRetrieveManpage (FILE *fp);

#endif
