/******************************************************************************
 *
 * neo7.h  -  headers for neo7.c
 *
 * Copyright Helge Ritter, 1994
 *
 * $Source$
 * $Log$
 * Revision 1.3  1997/04/02 12:47:01  helge
 * several minor corrections, among them: better handling of operator scopes,
 * ~-expansion in .neofolders-file, unloading of dynamic folders now works,
 * save gz file now safeguarded against specification of non-existent dir.
 *
 * Revision 1.2  1997/03/13  09:59:28  jan
 * Folder neuron extracted. Dependency cleanup No. 1: no more nst_defs.h.
 *
 * Revision 1.6  1997/01/31 20:02:40  helge
 * (minor changes or only touched)
 *
 * Revision 1.5  1997/01/14  14:35:16  helge
 * changes 135-139 bugs 131,132, numerous further small changes to
 * take care of (almost) all warnings under -Wall -O2
 * !!! Some Neo-structs have changed, trust the Makefile or  !!!
 * !!! recompile EVERYTHING !!!
 *
 * Revision 1.4  1995/07/31  10:34:53  helge
 * some changes: configuration now specified in neo_defs.h [base] and
 *               neo_user.h [additions]. Former neo7.c now neo_main.c
 *               Former neo8.c now neo7.c.
 *
 * Revision 1.2  1995/07/16 20:58:59  helge
 * added support for sending units to remote host(s) [in neo8.c]
 * better interface for container_unit
 *
 * Revision 1.1  1995/03/06  15:17:38  helge
 * source files for neo kernel.
 *
 *
 *****************************************************************************/
#ifndef __NEO7_H
#define __NEO7_H

extern void neo_rpc_cleanup (unitptr uIcon);
extern unitptr fetch_remote_icon(unitptr uIcon);
extern char* getRemoteHostOf(unitptr uIcon);
extern int isRemoteIcon(unitptr uIcon);

#endif
