/***********************************************************************
 * source file nst_jw.h
 * $Log$
 * Revision 1.5  1999/05/31 18:14:59  helge
 * Added inob-field (inob=interface-object) in *unitptr struct to allow some
 * Neo-related extensions. Other changes mainly removal of files from standard
 * libnst.a into dynamic folders (moved into foldersrc, cf. files added there)
 *
 * Revision 1.4  1997/05/07 09:40:38  helge
 * changed convolveSame(), convolveR() from void to int to return status info
 *
 * Revision 1.2  1997/03/13  10:54:20  jan
 * Dependency cleanup.
 *
 * Revision 1.13  1997/01/20 13:46:10  helge
 * various minor changes.
 *
 * Revision 1.12  1996/08/07  14:21:54  helge
 * New NST-Version 4.8 / Neo-Version 2.8  accumulating major changes
 *
 * Revision 1.11  1995/07/31  09:22:05  helge
 * some minor changes.
 *
 * Revision 1.9  1995/07/16 20:54:18  helge
 * enhanced rpc_unit to make remote units from neo's *.NST-files
 * extended nst_rpd.c, nst_rpd_add accordingly [changes disabled by
 * undefing NEO in nst_rpd_add.c]
 * provided 8-bit versions of some nst-units [nst_math8 etc.]
 *
 * Revision 1.8  1995/05/12  17:01:13  helge
 * temporary checki
 *
 * Revision 1.7  1994/10/20  00:52:00  helge
 * ..
 *
 * Revision 1.6  1994/09/04  17:28:50  walter
 * *** empty log message ***
 *
 * consider to "#define convolve convolveSame"  for compatibility
 * convolve() is a protected word for irix5
 * rename convolve() to convolveSame()
 ***********************************************************************/
#ifndef __NST_AUX1_H
#define __NST_AUX1_H

extern void combine_images(float *pix1, int dx1, int dy1, float *pix2,
                      int dx2, int dy2, float *pix3, 
                      int xoffset, int yoffset, int mode);
extern void get_subregion(float *pix1, int dx1, int dy1, float *pix2, int dx2, int dy2,
                   int xoffset, int yoffset);
extern int convolveR(float *pfIn, float *pfOut, float *pfMsk, 
              int dx, int dy, int iXll, int iYll,
              int iWidth, int iHeight, int mx, int my);
extern int convolveSame(float *pfIn, float *pfOut, float *pfMsk, 
              int dx, int dy, int mx, int my);
extern int nst_convolve_separable(float *pfIn, float *pfOut,
                      float *pfXMsk, /*  mask factor along x-direction */
                      float *pfYMsk, /*  mask factor along y-direction */
                      int iDx, int iDy,
                      int iXll, int iYll,
                      int iWidth, int iHeight, int iMx, int iMy);
extern int nst_max_convolve_separable(float *pfIn, float *pfOut,
                      float *pfXMsk, /*  mask factor along x-direction */
                      float *pfYMsk, /*  mask factor along y-direction */
                      int iDx, int iDy,
                      int iXll, int iYll,
                      int iWidth, int iHeight, int iMx, int iMy);
#endif
