#ifndef __NST_LINALG_H
#define __NST_LINALG_H

typedef struct MatrixProc_{
  Instruc_t *psCode;       /* ptr to the start of code */
  float     **ppfVar;      /* ptr to variables addresses */
  float     *pfVarStack;
  int       iVarStackSize; /* size of variable stack (in float elements) */
  int       iVarNum;       /* total nr of variables */
  int       iInpVarNum;    /* nr of input variables */
  char      **ppcVar;   /* char ptrs to variable names */
  int       *piVarOffset; /* index offset of each variable */
  int       *piVarColDim;
  int       *piVarRowDim;
  int       *piVarOut;  /* output fields associated */
  short int *piVarNoSave; /* flags set when variables shall not be saved */ 
  void      *uUnit;        /* unit to which program belongs */
} MatrixProc_t;

extern void nst_set_matrix_var_info(int,char**,int*,int*);
extern char *nst_interprete_matrix_expr(int, float**, float**, MatrixProc_t*);
extern char *nst_interprete_matrix_proc(int,float**,float**,MatrixProc_t*);
extern MatrixProc_t *nst_compile_matrix_proc(char*,int,char**,int*,int*,int*,int*,int*);
extern void nst_free_matrix_proc(MatrixProc_t*);
extern int nst_load_matrix_variables(FILE*,float**,MatrixProc_t*);
extern int nst_save_matrix_variables(FILE*,float**,MatrixProc_t*);
#endif
