
/*************************************************************************

   Version 1.0 of Source file nst_vect.h

   Copyright by Helge Ritter 1997

**************************************************************************/

#ifndef __NST_VECT_H
#define __NST_VECT_H

					/* obvious */
#define RADTODEG 57.29577951308232100
#define DEGTORAD  0.01745329251994330

/**************************************************************************/

extern  unittype *const_vec(int n ,float*, unittype *dest);
extern  unittype *sum_vec(int n ,unittype *dest);
extern  unittype *dif_vec(int n ,unittype *dest);

extern  unittype *mul_vec(int n,unittype *dest);

/**** cos_vec has been renamed to cos_angle. cos_vec is now a 
              different routine [defined in nst_funs.c (H.R.)] ****/
extern unitptr scale_vec(int,float,float,float,float,unitptr);

extern  unittype *out_prd(int n1, int n2, unittype *dest);
extern  unittype *out_div(int n1, int n2, unittype *dest);

extern  unittype *trf_vec(int n, int m, float (*f)(float), float* mat,
               float *vec, unitptr dest);

extern  unittype *trf1_vec(int n,float (*f)(float), unittype *dest);

extern  unittype *thr_vec(int n,float *threshhold, unittype *dest);
extern  unittype *threshold_vec(int n,float threshhold, unittype *dest);

extern unitptr extract_subvec(int,int,char*,unitptr);
extern unitptr insert_subvec(int,int,char*,unitptr);

/* threshholding of input vector. */

extern  unittype *scl_vec(int n,float *scale, unittype *dest);

/* scaling of input vector. */

extern  unittype *sup_vec(int n, int nvec, unittype *dest);
 
/* superposition of nvec input vectors */
/* scalar product of two input vectors */

extern  unittype *normalize_vec(int n, unittype *dest);
extern  unittype *sub_avg(int n, unittype *dest);

/* normalization of input vector to unit euclidean length. */
extern  unittype *bin_vec(int n, float a, float b, unittype *dest);
extern  unittype *lim_vec(int n, float a, float b, unittype *dest);

extern  unittype *min_vec(int n, unittype *dest);

extern  unittype *max_vec(int n, unittype *dest);

extern  unittype *cmp_vec(int n, int numf, float *beta, float (*f)(float), unittype *dest);
extern  unitptr base_vec(int, unitptr);

extern unitptr scale_vec8(int,float,float,float,float,unitptr);
extern  unittype *scl_vec8(int n,float *scale, unittype *dest);
extern  unittype *normalize_vec8(int n, unittype *dest);
extern  unittype *bin_vec8(int n, float a, float b, unittype *dest);
extern  unittype *min_vec8(int n, unittype *dest);
extern  unittype *max_vec8(int n, unittype *dest);
extern unitptr scale_vec16(int,float,float,float,float,unitptr);
extern  unittype *scl_vec16(int n,float *scale, unittype *dest);
extern  unittype *normalize_vec16(int n, unittype *dest);
extern  unittype *bin_vec16(int n, float a, float b, unittype *dest);
extern  unittype *min_vec16(int n, unittype *dest);
extern  unittype *max_vec16(int n, unittype *dest);
#endif
