/***************************************************************************
 * 
 * $File: $
 *
 * Utility routines for vector handling within prog-unit
 * compiles into "vector.so" package
 *
 * JW 07-98,02-99
 * $Id$
 * Log at file end
 ***************************************************************************/

#ifndef _VECTOR_H
#define _VECTOR_H

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <nst0.h>
#include <nst_dbug.h>
#include <sys/types.h>
#include <sys/time.h>
#include <ctype.h>
#include <find-nan.h>   /* after <math.h> ! */

#define LIBNAME "vector.so"

#ifndef DEG2RAD
#define RAD2DEG 57.2957795130823 /* 180/PI */
#define DEG2RAD 0.0174532925199433
#endif

#define _MIN(x,y) ((x)>(y)?(y):(x))
#define _MAX(x,y) ((x)<(y)?(y):(x))

extern int   giStrictDim;	/* change with setDimMatchIsStrict() */


extern int nst_prog_unit_id(void);
#define THISGROUPID()  nst_prog_unit_id()

#define OBJMAGIC_VECTOR 0xabcd	/* used for vector storage */
#define objRegister(ptr, free, iMagic,iId,tId ) \
        obj_register_grp((ptr),free,iMagic,(iId),(tId),THISGROUPID())
                    

extern int   _cntNaN(float*,int);
extern int   _cpNonNaN(float*,float*,int);
extern int   _swapNaN(float*,int);
extern int   _replaceNaN(float*,int,float);
extern float jw_stat4(int *, float **);
extern int   getMinMax(float *pfMi, float *pfMa, float *pfX, int iD);

extern int   printf_pi(char* pcFmt, int *piX,   int iD, int iSplit);
extern int   printf_pf(char* pcFmt, float *pfX, int iD, int iSplit);
extern int   printf_pd(char* pcFmt, double *pdX, int iD, int iSplit);


						     
#if !defined( SAY ) && ! defined ( _SAY )
#define _SAY
	/* 
	 *  USEFUL FOR DEBUGGING:
	 *	SAY("hallo world");
	 *	SAYS(("%s,%d", tDyn, iN ));
	 *
	 * CAUTION SAYS need double (( )) !
	 * before including this file you can define
	 * #define __THISFILE__ "src_file_name"
	 * in order to shorten the identifier name (w/o dir)
	 * default is the full name with relative path
	 */
#ifndef __THISFILE__		
#define __THISFILE__  __FILE__
#endif
extern int nst_dbg_printf(const char *pcFmt, ...);

#define SAY(x)	nst_dbg_printf("IN %s:%d``%s''\n", __THISFILE__,__LINE__,(x))
#define SAYS(x) (nst_dbg_printf("IN %s:%d ``", __THISFILE__,__LINE__),  \
			nst_dbg_printf x, nst_dbg_printf("''\n"))
#define PRINTFV(v,l) {int z;for(z=0;z<(l);z++)printf("%g ",v[z]);\
                      printf(" ::%s:%d\n",__THISFILE__,__LINE__);}
#endif

#endif /* .._H */

/* 
 * $Log$
 * Revision 1.7  2000/05/04 09:00:31  helge
 * changed SAY() and SAYS() to print to stderr
 *
 * Revision 1.6  2000/01/13 18:16:23  walter
 * moved nan.h to find-nan.h
 *
 * Revision 1.5  1999/12/09 16:23:48  walter
 * nan-stuff
 *
 * Revision 1.4  1999/07/06 12:00:29  walter
 * moved <nan.h> handling to vector.h,  fixed Log-ident-tag
 *
 */
