/***************************************************************************
 * 
 * $File: $
 *
 * Utility routines for h2graph handling within prog-unit
 * compiles into "vector.so" package
 *
 * JW 07-98,02-99
 * $Id$
 * Log at file end
 ***************************************************************************/

#ifndef _VECTOR_OBJ_H
#define _VECTOR_OBJ_H

#define TAB_IDX		    float
#define TAB_IDX_EQU(a,b)    ((a)==(b))
#define TAB_IDX_CPY(E,fIdx) E->idx=(fIdx)
#define TAB_IDX_FREE(E)     
#define RETURN_ON_BAD_CMPIDX(searchIdx)     

#ifndef TAB_pRES
#define TAB_pRES   	    void*
#endif
#define _TABENTRY_MORE

struct _TABENTRY {
	TAB_pRES	ptr;
	TAB_IDX		idx;
    struct _TABENTRY *	next;
#ifdef _TABENTRY_MORE 
  int   iMagic;			/* magic number */
  int   iGrp;			/* group or unit, free obj if grp gets deleted */
  int   iId;			/* ident */
  char* tId;			/* obj ident string, not free, e.g. __FILE__ */
  void  (*Free)(TAB_pRES);	/* free function */
#endif
} ;
typedef struct _TABENTRY TABENTRY;

struct _TABLE{
	char     *	tId;
	int		iNumEntries;
	int		iAddAtHead; /* if set entries get added at head FILO */
	TABENTRY *	pFirst;
} ;
typedef struct _TABLE TABLE;


extern	TABLE *	newTable(    char  * tName);
extern	TABENTRY*tableAdd(    TABLE * psTab, TAB_IDX newIdx, TAB_pRES newPtr);
extern  TABENTRY*tableAddHead(TABLE * psTable, TAB_IDX newIdx, TAB_pRES newPtr);
extern TAB_pRES tableGet(    TABLE * psTab, TAB_IDX searchIdx);
extern TABENTRY*tableGetEntry( TABLE * psTable, TAB_IDX searchIdx);
extern TABENTRY*tableGetEntryByNum( TABLE * psTable, int iNum );
extern TAB_pRES tableRemove( TABLE * psTab, TAB_IDX searchIdx);
extern	int	tableForeach(TABLE * psTab, int (*applyFxn)(TAB_pRES,TAB_IDX, int));
extern	void	tableKill(   TABLE * psTab);
extern int	tableCntMatchingEntries(TABLE *psT, 			\
			TAB_pRES pMatch, int (*matchFxn)(TAB_pRES,TAB_pRES) );
extern int	tableRemoveMatchingEntries(TABLE *psT,			\
			TAB_pRES pMatch, int (*matchFxn)(TAB_pRES,TAB_pRES) );
extern int	tablePntMatchFxn	(TAB_pRES ptr, TAB_pRES pMatch);
extern int	tableStrMatchFxn	(char* ptr, char* tMatch);

/*
 * $Log$
 * Revision 1.1  1999/05/20 17:15:06  walter
 * create header file vector_obj.h
 *
 */

#endif  /* _VECTOR_OBJ_H */

